#include "stm32f4xx_hal.h"
#include "DFL168A_Async.h"
GPSClass::GPSClass(){
  Baudrate=9600;
  Timeout=500;  //time out is 500ms;
  Pareant=NULL;
}

GPSClass::GPSClass(long Baudrate,int Timeout, class DFL168A * Pareant ){
  this->Baudrate=Baudrate;
  this->Timeout=Timeout;
  this->Pareant=Pareant;
}
byte GPSClass::SendGPSCMD(const unsigned char * CMD)
{
  static byte retrnV=SUCCESS;
  //Jan 10 2021 for peek '>'-------start
  //unsigned long tick4timeout;
  static uint32_t tick4timeout;
  //Jan 10 2021 for peek '>'-------End
  String StrResult;
  if (WAITING!=retrnV) {tick4timeout=millis(); Pareant->mySerial->println(CMD); }
  if (Pareant->mySerial->available()<=3) 
  {
    if (millis()-tick4timeout<=(Timeout+50u))
    {
      Pareant->mySerial->poll();
      retrnV=WAITING; return WAITING;   
    }
    else
    {
      //time out
      while (Pareant->mySerial->available()) Pareant->mySerial->read(); //clear buffer
      retrnV=FAIL; return FAIL;
    }        
  } 
  //Jan 10 2021 for peek '>'-------start
  if (!Pareant->mySerial->peek('>'))
  {
    if (millis()-tick4timeout<=(Timeout+50u))
    {
    	retrnV=WAITING; return WAITING;
    }
    else
    {
    	Pareant->mySerial->Rx_Head=Pareant->mySerial->Rx_Tail;   //clear Receiving buffer
    	retrnV=FAIL; return FAIL;
    }
  }
  //Jan 10 2021 for peek '>'-------end
  StrResult=Pareant->mySerial->readStringUntil('>');
  StrResult.trim(); 
  if ( StrResult=="OK") retrnV=SUCCESS; else retrnV=FAIL;
  
  return  retrnV;
}

#if 0   //Jan 10 2021 for peek '>'
byte GPSClass::getGPSinfo(float &Latitude,float &Longitude, int &Speed /*Km/h*/, String &Time /*hh:mm::ss*/, String &Date /*dd/mm/yyyy*/)
{
  byte retrnV;
  unsigned long tick4timeout;
  String StrResult;
  String subStringR;
  int Space_Index;
  float tempF;
  char XXX[15];
  bool Minus_Result;
  /*
  Pareant->mySerial->setTimeout(Timeout+50);
  if (!Pareant->ATCommand("ATDEV1SIGBSOF1")) {  Pareant->mySerial->setTimeout((Pareant->Timeout)+50); return false;}   //"AT DEV1 SI GB SOF 3" FOR GMC Sentence
  Pareant->mySerial->setTimeout((Pareant->Timeout)+50);
  */
  retrnV=SendGPSCMD((const unsigned char *)"ATDEV1SIGBSOF1");
  if ((WAITING==retrnV)||(FAIL==retrnV)) {return retrnV;}

  Pareant->mySerial->println((const unsigned char *)"AT DEV1 LAT");
  StrResult=Pareant->mySerial->readStringUntil('>');
  StrResult.trim();  //"+25 33.456'"
  /*
  if (StrResult=="") return false;
  if ('?'==StrResult.charAt(0)) return false;
  if ('N'==StrResult.charAt(0)) return false;*/

  if (StrResult=="") {retrnV=FAIL; return retrnV;}
  if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}

  if ('-'==StrResult.charAt(0)) Minus_Result=true;  else Minus_Result=false; //in case "-0 22.89'" ,How about ""-78.98'" ? we don't know if it has "0 " before 78.98'  Check 20 0' situation: 20 or 20 0' in DFL168A source code
  Space_Index=StrResult.indexOf(' ');
  subStringR=StrResult.substring(0,Space_Index);
  subStringR.toCharArray(XXX,15);
  tempF=atof(XXX);
  Latitude=tempF;

  StrResult=StrResult.substring(Space_Index+1);
  Space_Index=StrResult.indexOf('\'');
  subStringR=StrResult.substring(0,Space_Index);
  subStringR.toCharArray(XXX,15);
  tempF=atof(XXX);
  tempF=tempF/60.0;
  if (Minus_Result) Latitude-=tempF; else Latitude+=tempF;

  Pareant->mySerial->println((const unsigned char *)"AT DEV1 LONG");
  StrResult=Pareant->mySerial->readStringUntil('>');
  StrResult.trim();  //"+25 33.456'"
  /*
  if (StrResult=="") return false;
  if ('?'==StrResult.charAt(0)) return false;
  if ('N'==StrResult.charAt(0)) return false;*/

  if (StrResult=="") {retrnV=FAIL; return retrnV;}
  if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}

  if ('-'==StrResult.charAt(0)) Minus_Result=true;  else Minus_Result=false;  //in case "-0 22.89'" ,How about ""-78.98'" ? we don't know if it has "0 " before 78.98'
  Space_Index=StrResult.indexOf(' ');
  subStringR=StrResult.substring(0,Space_Index);
  subStringR.toCharArray(XXX,15);
  tempF=atof(XXX);
  Longitude=tempF;

  StrResult=StrResult.substring(Space_Index+1);
  Space_Index=StrResult.indexOf('\'');
  subStringR=StrResult.substring(0,Space_Index);
  subStringR.toCharArray(XXX,15);
  tempF=atof(XXX);
  tempF=tempF/60.0;
  if (Minus_Result) Longitude-=tempF; else Longitude+=tempF;

  Pareant->mySerial->println((const unsigned char *)"AT DEV1 SPEED");
  StrResult=Pareant->mySerial->readStringUntil('>');
  StrResult.trim();  //"56.7"

  /*
  if (StrResult=="") return false;
  if ('?'==StrResult.charAt(0)) return false;
  if ('N'==StrResult.charAt(0)) return false;  */

  if (StrResult=="") {retrnV=FAIL; return retrnV;}
  if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}

  StrResult.toCharArray(XXX,15);
  tempF=atof(XXX);
  Speed=tempF*1.852;

  Pareant->mySerial->println((const unsigned char *)"AT DEV1 TIME");
  StrResult=Pareant->mySerial->readStringUntil('>');
  StrResult.trim();  //"20:58:31"
  /*
  if (StrResult=="") return false;
  if ('?'==StrResult.charAt(0)) return false;
  if ('N'==StrResult.charAt(0)) return false;
   */
  if (StrResult=="") {retrnV=FAIL; return retrnV;}
  if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  Time=StrResult;


  Pareant->mySerial->println((const unsigned char *)"AT DEV1 DATE");
  StrResult=Pareant->mySerial->readStringUntil('>');
  StrResult.trim();  //"20:58:31"
  /*
  if (StrResult=="") return false;
  if ('?'==StrResult.charAt(0)) return false;
  if ('N'==StrResult.charAt(0)) return false; */

  if (StrResult=="") {retrnV=FAIL; return retrnV;}
  if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}

  Date=StrResult;

  return retrnV;
}
#else
byte GPSClass::getGPSinfo(float &Latitude,float &Longitude, int &Speed /*Km/h*/, String &Time /*hh:mm::ss*/, String &Date /*dd/mm/yyyy*/)
{
  //byte retrnV;
  static byte retrnV=SUCCESS;
  static uint32_t tick4timeout;
  String StrResult;
  String subStringR;
  int Space_Index;
  float tempF;
  char XXX[15];
  bool Minus_Result;
  static unsigned char stateM=0;

  static float Latitude_mirror;
  static float Longitude_mirror;
  static int Speed_mirror;
  static String Time_mirror;

  /*
  Pareant->mySerial->setTimeout(Timeout+50);
  if (!Pareant->ATCommand("ATDEV1SIGBSOF1")) {  Pareant->mySerial->setTimeout((Pareant->Timeout)+50); return false;}   //"AT DEV1 SI GB SOF 3" FOR GMC Sentence
  Pareant->mySerial->setTimeout((Pareant->Timeout)+50);
  */
  if (0==stateM)
  {
    //retrnV=SendGPSCMD((const unsigned char *)"ATDEV1SIGBSOF1");
	if (retrnV!=WAITING)
	{
		tick4timeout=millis();
		retrnV=SendGPSCMD((const unsigned char *)"ATDEV1SIGBSOF1");
		return retrnV;
	}
    if ((WAITING==retrnV)||(FAIL==retrnV)) {
    	if (FAIL==retrnV)
    	{
    		stateM=0;
    	}
    	else
    	{
    		retrnV=SendGPSCMD((const unsigned char *)"ATDEV1SIGBSOF1");
    	}
    	return retrnV;}
    else
    {
    	retrnV=100;
    	stateM=1;
    	return WAITING;
    }
  }
  //Pareant->mySerial->println((const unsigned char *)"AT DEV1 LAT");
  //StrResult=Pareant->mySerial->readStringUntil('>');
  //StrResult.trim();  //"+25 33.456'"
  //if (StrResult=="") {retrnV=FAIL; return retrnV;}
  //if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  //if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}

  //if ('-'==StrResult.charAt(0)) Minus_Result=true;  else Minus_Result=false; //in case "-0 22.89'" ,How about ""-78.98'" ? we don't know if it has "0 " before 78.98'  Check 20 0' situation: 20 or 20 0' in DFL168A source code
  //Space_Index=StrResult.indexOf(' ');
  //subStringR=StrResult.substring(0,Space_Index);
  //subStringR.toCharArray(XXX,15);
  //tempF=atof(XXX);
  //Latitude=tempF;

  //StrResult=StrResult.substring(Space_Index+1);
  //Space_Index=StrResult.indexOf('\'');
  //subStringR=StrResult.substring(0,Space_Index);
  //subStringR.toCharArray(XXX,15);
  //tempF=atof(XXX);
  //tempF=tempF/60.0;
  //if (Minus_Result) Latitude-=tempF; else Latitude+=tempF;
  else if (1==stateM)
  {
	  if (100==retrnV)
	  {
		  tick4timeout=millis();
		  Pareant->mySerial->println((const unsigned char *)"AT DEV1 LAT");
		  retrnV=WAITING;
		  return WAITING;
	  }
	  if (!Pareant->mySerial->peek('>'))
	  {
	      if (millis()-tick4timeout<Pareant->mySerial->TimeOut)
	      {
	      	retrnV=WAITING; return WAITING;
	      }
	      else
	      {
	      	Pareant->mySerial->Rx_Head=Pareant->mySerial->Rx_Tail;   //clear Receiving buffer
	      	stateM=0;
	      	retrnV=FAIL; return FAIL;
	      }
	  }
	  //we got '>'
	  StrResult=Pareant->mySerial->readStringUntil('>');
	  StrResult.trim();  //"+25 33.456'"
	  if (StrResult=="") {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('?'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('N'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}

	  if ('-'==StrResult.charAt(0)) Minus_Result=true;  else Minus_Result=false; //in case "-0 22.89'" ,How about ""-78.98'" ? we don't know if it has "0 " before 78.98'  Check 20 0' situation: 20 or 20 0' in DFL168A source code
	  Space_Index=StrResult.indexOf(' ');
	  subStringR=StrResult.substring(0,Space_Index);
	  subStringR.toCharArray(XXX,15);
	  tempF=atof(XXX);
	  Latitude_mirror=tempF;

	  StrResult=StrResult.substring(Space_Index+1);
	  Space_Index=StrResult.indexOf('\'');
	  subStringR=StrResult.substring(0,Space_Index);
	  subStringR.toCharArray(XXX,15);
	  tempF=atof(XXX);
	  tempF=tempF/60.0;
	  if (Minus_Result) Latitude_mirror-=tempF; else Latitude_mirror+=tempF;

	  retrnV=100;
	  stateM=2;
	  return WAITING;
  }

  

  //Pareant->mySerial->println((const unsigned char *)"AT DEV1 LONG");
  //StrResult=Pareant->mySerial->readStringUntil('>');
  //StrResult.trim();  //"+25 33.456'"

  //if (StrResult=="") {retrnV=FAIL; return retrnV;}
  //if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  //if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}

  //if ('-'==StrResult.charAt(0)) Minus_Result=true;  else Minus_Result=false;  //in case "-0 22.89'" ,How about ""-78.98'" ? we don't know if it has "0 " before 78.98'
  //Space_Index=StrResult.indexOf(' ');
  //subStringR=StrResult.substring(0,Space_Index);
  //subStringR.toCharArray(XXX,15);
  //tempF=atof(XXX);
  //Longitude=tempF;

  //StrResult=StrResult.substring(Space_Index+1);
  //Space_Index=StrResult.indexOf('\'');
  //subStringR=StrResult.substring(0,Space_Index);
  //subStringR.toCharArray(XXX,15);
  //tempF=atof(XXX);
  //tempF=tempF/60.0;
  //if (Minus_Result) Longitude-=tempF; else Longitude+=tempF;
  else if (2==stateM)
  {
	  if (100==retrnV)
	  {
	  	 tick4timeout=millis();
	  	 Pareant->mySerial->println((const unsigned char *)"AT DEV1 LONG");
	  	 retrnV=WAITING;
	  	 return WAITING;
	  }
	  if (!Pareant->mySerial->peek('>'))
	  {
	  	if (millis()-tick4timeout<Pareant->mySerial->TimeOut)
	  	{
	  	   retrnV=WAITING; return WAITING;
	  	}
	  	else
	  	{
	  	   Pareant->mySerial->Rx_Head=Pareant->mySerial->Rx_Tail;   //clear Receiving buffer
	  	   stateM=0;
	  	   retrnV=FAIL; return FAIL;
	  	}
	  }
	  StrResult=Pareant->mySerial->readStringUntil('>');
	  StrResult.trim();  //"+25 33.456'"

	  if (StrResult=="") {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('?'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('N'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}

	  if ('-'==StrResult.charAt(0)) Minus_Result=true;  else Minus_Result=false;  //in case "-0 22.89'" ,How about ""-78.98'" ? we don't know if it has "0 " before 78.98'
	  Space_Index=StrResult.indexOf(' ');
	  subStringR=StrResult.substring(0,Space_Index);
	  subStringR.toCharArray(XXX,15);
	  tempF=atof(XXX);
	  Longitude_mirror=tempF;

	  StrResult=StrResult.substring(Space_Index+1);
	  Space_Index=StrResult.indexOf('\'');
	  subStringR=StrResult.substring(0,Space_Index);
	  subStringR.toCharArray(XXX,15);
	  tempF=atof(XXX);
	  tempF=tempF/60.0;
	  if (Minus_Result) Longitude_mirror-=tempF; else Longitude_mirror+=tempF;
	  retrnV=100;
	  stateM=3;
	  return WAITING;
  }

  //Pareant->mySerial->println((const unsigned char *)"AT DEV1 SPEED");
  //StrResult=Pareant->mySerial->readStringUntil('>');
  //StrResult.trim();  //"56.7"



  //if (StrResult=="") {retrnV=FAIL; return retrnV;}
  //if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  //if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}

  //StrResult.toCharArray(XXX,15);
  //tempF=atof(XXX);
  //Speed=tempF*1.852;

  

  else if (3==stateM)
  {
	  if (100==retrnV)
	  {
	  	 tick4timeout=millis();
	  	 Pareant->mySerial->println((const unsigned char *)"AT DEV1 SPEED");
	  	 retrnV=WAITING;
	  	 return WAITING;
	  }
	  if (!Pareant->mySerial->peek('>'))
	  {
	  	if (millis()-tick4timeout<Pareant->mySerial->TimeOut)
	  	{
	  	   retrnV=WAITING; return WAITING;
	  	}
	  	else
	  	{
	  	   Pareant->mySerial->Rx_Head=Pareant->mySerial->Rx_Tail;   //clear Receiving buffer
	  	   stateM=0;
	  	   retrnV=FAIL; return FAIL;
	  	}
	  }
	  StrResult=Pareant->mySerial->readStringUntil('>');
	  StrResult.trim();  //"56.7"



	  if (StrResult=="") {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('?'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('N'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}

	  StrResult.toCharArray(XXX,15);
	  tempF=atof(XXX);
	  Speed_mirror=tempF*1.852;
	  retrnV=100;
	  stateM=4;
	  return WAITING;

  }

  //Pareant->mySerial->println((const unsigned char *)"AT DEV1 TIME");
  //StrResult=Pareant->mySerial->readStringUntil('>');
  //StrResult.trim();  //"20:58:31"

  //if (StrResult=="") {retrnV=FAIL; return retrnV;}
  //if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  //if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  //Time=StrResult;
  else if (4==stateM)
  {
	  if (100==retrnV)
	  {
	  	 tick4timeout=millis();
	  	 Pareant->mySerial->println((const unsigned char *)"AT DEV1 TIME");
	  	 retrnV=WAITING;
	  	 return WAITING;
	  }
	  if (!Pareant->mySerial->peek('>'))
	  {
	  	if (millis()-tick4timeout<Pareant->mySerial->TimeOut)
	  	{
	  	   retrnV=WAITING; return WAITING;
	  	}
	  	else
	  	{
	  	   Pareant->mySerial->Rx_Head=Pareant->mySerial->Rx_Tail;   //clear Receiving buffer
	  	   stateM=0;
	  	   retrnV=FAIL; return FAIL;
	  	}
	  }
	  StrResult=Pareant->mySerial->readStringUntil('>');
	  StrResult.trim();  //"20:58:31"
	  if (StrResult=="") {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('?'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('N'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}
	  Time_mirror=StrResult;
	  retrnV=100;
	  stateM=5;
	  return WAITING;
  }
  
  //Pareant->mySerial->println((const unsigned char *)"AT DEV1 DATE");
  //StrResult=Pareant->mySerial->readStringUntil('>');
  //StrResult.trim();  //"20:58:31"

  
  //if (StrResult=="") {retrnV=FAIL; return retrnV;}
  //if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  //if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
   
  //Date=StrResult;
  
  //return retrnV;
  else if (5==stateM)
  {
	  if (100==retrnV)
	  {
	  	 tick4timeout=millis();
	  	 Pareant->mySerial->println((const unsigned char *)"AT DEV1 DATE");
	  	 retrnV=WAITING;
	  	 return WAITING;
	  }
	  if (!Pareant->mySerial->peek('>'))
	  {
	  	if (millis()-tick4timeout<Pareant->mySerial->TimeOut)
	  	{
	  	   retrnV=WAITING; return WAITING;
	  	}
	  	else
	  	{
	  	   Pareant->mySerial->Rx_Head=Pareant->mySerial->Rx_Tail;   //clear Receiving buffer
	  	   stateM=0;
	  	   retrnV=FAIL; return FAIL;
	  	}
	  }
	  StrResult=Pareant->mySerial->readStringUntil('>');
	  StrResult.trim();  //"20:58:31"


	  if (StrResult=="") {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('?'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('N'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}
	  Date=StrResult;

	  Latitude=Latitude_mirror;
      Longitude=Longitude_mirror;
	  Speed=Speed_mirror;
	  Time=Time_mirror	;

	  stateM=0;
	  retrnV=SUCCESS;
	  return retrnV;
  }
}
#endif

byte GPSClass::getAltitude(float &Altitude /*Meter*/)
{
#if 0	//Jan 10 2021 for peek '>'
  byte retrnV;
#else
  static byte retrnV=SUCCESS;
  static uint32_t tick4timeout;
  static unsigned char stateM=0;
#endif
  String StrResult;  
  char XXX[15];
  //Jan 10 2021 for peek '>'-----start
  //retrnV=SendGPSCMD((const unsigned char *)"ATDEV1SIGBSOF2");
  //if ((WAITING==retrnV)||(FAIL==retrnV)) {return retrnV;}
  if (0==stateM)
  {
    if (retrnV!=WAITING)
  	{
  		tick4timeout=millis();
  		retrnV=SendGPSCMD((const unsigned char *)"ATDEV1SIGBSOF2");
  		return retrnV;
  	}
    if ((WAITING==retrnV)||(FAIL==retrnV)) {
     	if (FAIL==retrnV)
      	{
      		stateM=0;
      	}
     	else
     	{
     		retrnV=SendGPSCMD((const unsigned char *)"ATDEV1SIGBSOF2");
     	}
      	return retrnV;}
    else
    {
      	retrnV=100;
      	stateM=1;
      	return WAITING;
    }
  }
  //Jan 10 2021 for peek '>'-----end
#if 0	//Jan 10 2021 for peek '>'
  Pareant->mySerial->println((const unsigned char *)"AT DEV1 ALT");
  StrResult=Pareant->mySerial->readStringUntil('>'); 
  StrResult.trim();  //"5608"     
  /*
  if (StrResult=="") return false;
  if ('?'==StrResult.charAt(0)) return false;
  if ('N'==StrResult.charAt(0)) return false;  */

  if (StrResult=="") {retrnV=FAIL; return retrnV;}
  if ('?'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  if ('N'==StrResult.charAt(0)) {retrnV=FAIL; return retrnV;}
  
  StrResult.toCharArray(XXX,15);
  Altitude=atof(XXX);    
  return true;
#else
  else if (1==stateM)
  {
	  if (100==retrnV)
	  {
	  	  tick4timeout=millis();
	  	  Pareant->mySerial->println((const unsigned char *)"AT DEV1 ALT");
	  	  retrnV=WAITING;
	  	  return WAITING;
	  }
	  if (!Pareant->mySerial->peek('>'))
	  {
	  	  if (millis()-tick4timeout<Pareant->mySerial->TimeOut)
	  	  {
	  	     retrnV=WAITING; return WAITING;
	  	  }
	  	  else
	  	  {
	  	     Pareant->mySerial->Rx_Head=Pareant->mySerial->Rx_Tail;   //clear Receiving buffer
	  	     stateM=0;
	  	     retrnV=FAIL; return FAIL;
	  	  }
	  }
	  StrResult=Pareant->mySerial->readStringUntil('>');
	  StrResult.trim();  //"5608"
	  if (StrResult=="") {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('?'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}
	  if ('N'==StrResult.charAt(0)) {stateM=0;retrnV=FAIL; return retrnV;}

	  StrResult.toCharArray(XXX,15);
	  Altitude=atof(XXX);

	  stateM=0;
	  retrnV=SUCCESS;
	  return retrnV;
  }
#endif
}


