
/*
 * myPriv.cpp
 *
 *  Created on: Dec. 22, 2020
 *      Author: Jack Xia Laptop
 */
#define IMPLEMENT4UARTCFG
#include <uart_cfg.h>
#include "WString.h"
uint32_t millis()
{
	return HAL_GetTick();
}

void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)
{
	HardwareSerial * mySeri;
    #if UART_Num==1
	  mySeri=&Serial1;
	  if (&huart1==huart)
    #elif UART_Num==2
	  mySeri=&Serial2;
	  if (&huart2==huart)
    #elif UART_Num==3
	  mySeri=&Serial3;
	  if (&huart3==huart)
    #elif UART_Num==4
	  mySeri=&Serial4;
	  if (&huart4==huart)
    #endif
	{
		  mySeri->RxCplt=1;

	}
}

void HAL_UART_TxCpltCallback(UART_HandleTypeDef *huart)
{
	HardwareSerial * mySeri;
	#if UART_Num==1
		mySeri=&Serial1;
		if (&huart1==huart)
	#elif UART_Num==2
		mySeri=&Serial2;
		if (&huart2==huart)
	#elif UART_Num==3
		mySeri=&Serial3;
		if (&huart3==huart)
	#elif UART_Num==4
		mySeri=&Serial4;
		if (&huart4==huart)
	#endif
	{
			mySeri->TxCplt=1;

	}
}

HardwareSerial::HardwareSerial(UART_HandleTypeDef * huart)
{
	//this->huart=*huart;  //has problem :  huart2 has no initilized , you copy zero value
	this->phuart=huart;
	Tx_Head=Tx_Tail=0;
	Rx_Head=Rx_Tail=0;
	Index4Rx_insdeHAL=0;
	TimeOut=300;  //300ms
	//RxCplt=0;
	//TxCplt=0;
}
bool HardwareSerial::RxRingBufferFull()
{
	if ((Rx_Tail+1)==(Rx_Head)) return true;
	return false;
}
bool HardwareSerial::RxRingBufferEmpty()
{
	if ((Rx_Tail)==(Rx_Head)) return true;
	return false;
}
bool HardwareSerial::TxRingBufferFull()
{
	if ((Tx_Tail+1)==(Tx_Head)) return true;
	return false;
}
bool HardwareSerial::TxRingBufferEmpty()
{
	if ((Tx_Tail)==(Tx_Head)) return true;
	return false;
}

void HardwareSerial::poll()
{

	//Receive:
	while (Index4Rx_insdeHAL<((phuart->RxXferSize-phuart->RxXferCount)))
	{
		RxRingBuffer[Rx_Tail]=RxBuffer4HAL[Index4Rx_insdeHAL];
		Index4Rx_insdeHAL++;
		Rx_Tail++;
	}
	if (RxCplt)
	{
		//in case , receive data again
		while (Index4Rx_insdeHAL<((phuart->RxXferSize-phuart->RxXferCount)))
		{
			RxRingBuffer[Rx_Tail]=RxBuffer4HAL[Index4Rx_insdeHAL];
			Index4Rx_insdeHAL++;
			Rx_Tail++;
		}
		//Start receive
		Index4Rx_insdeHAL=0;
		HAL_UART_Receive_IT(phuart,RxBuffer4HAL, 255);
		RxCplt=0;
	}

	//Transmit
	if (TxCplt)
	{
		if (!TxRingBufferEmpty())
		{
			uint8_t i=0;
			while (!TxRingBufferEmpty())
			{
				TxBuffer4HAL[i++]=TxRingBuffer[Tx_Head++];

			}
			HAL_UART_Transmit_IT(phuart,TxBuffer4HAL, i);
			//Tx_Head=Tx_Tail;  //It should be equal
			TxCplt=0;
		}
	}


}

void HardwareSerial:: setTimeout(uint32_t to)
{
	TimeOut=to;
}

void HardwareSerial::begin()
{
	RxCplt=0;
	HAL_UART_Receive_IT(phuart,RxBuffer4HAL, 255);   //first time receive, we cannot use RxCplt=1 because huart.RxXferSize and huart.RxXferCount have no value  before calling HAL_UART_Receive_IT(
	TxCplt=1;  //first time for receiving
}

uint8_t HardwareSerial::available()
{
	return (Rx_Tail-Rx_Head);

}

int16_t HardwareSerial::read()
{
	if (RxRingBufferEmpty()) return -1;
	return RxRingBuffer[Rx_Head++];
}

String HardwareSerial::readString()
{
	String result;
	unsigned char str[256];
	int i;
	uint32_t tick4Read;
	tick4Read=millis();
	startRec:
	if (available())
	{   i=0;
		while (available())
		{
			str[i++]=RxRingBuffer[Rx_Head++];
			poll();
		}
		str[i]='\0';
		result=String((const char*)str);
		return result;

	}
	else
	{  //no receive
		while (millis()-tick4Read<TimeOut)
		{
			poll();
			if (available()) goto startRec;
		}
		str[0]='\0';
		result=String((const char*)str);
		return result;
	}

}

#if 0  //We will use #else part of "#if 0   ... #else   ... #endif"  because we only peek('>'), it will save time
bool HardwareSerial::peek(unsigned char ch)
{
	unsigned char i;
	if (Rx_Head==Rx_Tail)  return false;
	for (i=Rx_Head;i!=Rx_Tail;i++)
	{
		if (RxRingBuffer[i]==ch)
		{
			return true;
		}
	}
	return false;
}
#else
bool HardwareSerial::peek(unsigned char ch)
{   static unsigned char Rx_Head_Static=0;
	unsigned char i;
	if (Rx_Head==Rx_Tail) { Rx_Head_Static=Rx_Head; return false;}
	for (i=Rx_Head_Static;i!=Rx_Tail;i++)
	{
		if (RxRingBuffer[i]==ch)
		{
			Rx_Head_Static=i+1;
			return true;
		}
	}
	Rx_Head_Static=Rx_Tail;
	return false;
}
#endif

String HardwareSerial::readStringUntil(unsigned char ch)
{
	String result;
	unsigned char str[256];
	int i;
	uint32_t tick4Read;
	tick4Read=millis();
	startRec:
	if (available())
	{   i=0;
	    we_continue:
		while (available())
		{
			str[i]=RxRingBuffer[Rx_Head++];
			if (str[i++]==ch)
			{
				//str[i]='\0';
				str[i-1]='\0';  //we discard ch
				result=String((const char*)str);
				return result;
			}
			poll();
			tick4Read=millis();
		}
		while (millis()-tick4Read<TimeOut)
		{
			poll();
			if (available()) goto  we_continue;
		}
		str[0]='\0';
		result=String((const char*)str);
		return result;

	}
	else
	{  //no receive
		while (millis()-tick4Read<TimeOut)
		{
			poll();
			if (available()) goto startRec;
		}
		str[0]='\0';
		result=String((const char*)str);
		return result;
	}

}

void HardwareSerial::write(unsigned char ch)
{
	if (TxRingBufferFull()) return;
	TxRingBuffer[Tx_Tail++]=ch;
}
void HardwareSerial::print(const unsigned char * str)
{   int i=0;
	while (str[i]!='\0')
	{
		write(str[i++]);
	}
}
void HardwareSerial::println(const unsigned char * str)
{
	print(str);
	print((const unsigned char *)"\r\n");
}

bool isHexadecimalDigit(const unsigned char ch)
{
	if (ch>='0' && ch<='9') return true;
	if (ch>='a' && ch<='f') return true;
	if (ch>='A' && ch<='F') return true;
	return false;

}
bool isSpace(const unsigned char ch)
{
	if (ch==' ' || ch=='\t') return true;
	return false;
}
void delay(uint32_t d)
{
	uint32_t tick4Delay;
	HardwareSerial * mySeri;
	tick4Delay=millis();
	    #if UART_Num==1
		  mySeri=&Serial1;
	    #elif UART_Num==2
		  mySeri=&Serial2;
	    #elif UART_Num==3
		  mySeri=&Serial3;
	    #elif UART_Num==4
		  mySeri=&Serial4;
	    #endif

	while (millis()-tick4Delay<d)
	{
		mySeri->poll();
	}

}
