/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "DFL168A_Async.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
UART_HandleTypeDef huart2;

/* USER CODE BEGIN PV */
DFL168A myDFL168A(J1939_PROTOCOL, 1000, 500000, 9600, 500);
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_USART2_UART_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  bool Vehicle_OK;
  String Vin;
  float VehicleSpeed;
  float BarometricPressure;
  int temperature;
  byte StateMachine = 0;
  byte result;
  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_USART2_UART_Init();
  /* USER CODE BEGIN 2 */

  /* USER CODE END 2 */
  Vehicle_OK = myDFL168A.begin(true, false);
  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
	 myDFL168A.SerialPoll();   //must add it, it is very important
	 if (Vehicle_OK)
	 {
		 switch (StateMachine)
		 {
		 case 0:
			 result = myDFL168A.J1939.getVIN(Vin);
			 if (WAITING == result) break;
			 if (SUCCESS == result)
			 {
				 //Success in getting VIN 
				 //Customer code for acccess Vin when success---Begin


				 //Customer code for acccess Vin when success---End
			 }
			 else
			 {
				 //Fail in getting VIN 
				 //Customer code when failure ---Begin


				 //Customer code when failure---End
			 }
			 StateMachine = 1;
			 break;
		 case 1:
			 result = myDFL168A.J1939.PGN65269.refresh();
			 if (WAITING == result) break;
			 if (SUCCESS == result)
			 {
				 //Success in getting PGN65269
				 if (myDFL168A.J1939.PGN65269.getBarometricPressure(BarometricPressure))
				 {
					 //Success in getting BarometricPressure 
					 //Customer code for acccess BarometricPressure when success---Begin


					 //Customer code for acccess BarometricPressure when success---End
				 }
				 else
				 {
					 //Fail in getting BarometricPressure 
					 //Customer code when failure ---Begin


					 //Customer code when failure---End
				 }

				 if (myDFL168A.J1939.PGN65269.getAmbientTemp(temperature))
				 {
					 //Success in getting temperature 
					 //Customer code for acccess temperature when success---Begin


					 //Customer code for acccess temperature when success---End
				 }
				 else
				 {
					 //Fail in getting temperature 
					 //Customer code when failure ---Begin


					 //Customer code when failure---End
				 }
			 }
			 else
			 {
				 //Fail in getting PGN65269 
				 //Customer code when failure ---Begin


				 //Customer code when failure---End
			 }
			 StateMachine = 2;
			 break;
		 case 2:
			 result = myDFL168A.J1939.PGN65265.refresh();
			 if (WAITING == result) break;
			 if (SUCCESS == result)
			 {
				 //Success in getting PGN65265
				 if (myDFL168A.J1939.PGN65265.getWheelBasedVehicleSpeed(VehicleSpeed))
				 {
					 //Success in getting VehicleSpeed
					 //Customer code for acccess VehicleSpeed when success---Begin


					 //Customer code for acccess VehicleSpeed when success---End
				 }
				 else
				 {
					 //Fail in getting VehicleSpeed
					 //Customer code when failure ---Begin


					 //Customer code when failure---End
				 }
			 }
			 else
			 {
				 //Fail in getting PGN65265
				 //Customer code when failure ---Begin


				 //Customer code when failure---End
			 }
			 StateMachine = 3;
			 break;
		 case 3:
			 result = myDFL168A.J1939.clearDTC();
			 if (WAITING == result) break;
			 if (SUCCESS == result)
			 {
				 //Success in Clear DTC
				 //Customer code when success---Begin


				 //Customer code when success---End
			 }
			 else
			 {
				 //Fail in Clear DTC
				 //Customer code when failure ---Begin


				 //Customer code when failure---End
			 }
			 StateMachine = 0;
		 }
	 }
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
  RCC_OscInitStruct.PLL.PLLM = 8;
  RCC_OscInitStruct.PLL.PLLN = 168;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 7;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_5) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief USART2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART2_UART_Init(void)
{

  /* USER CODE BEGIN USART2_Init 0 */

  /* USER CODE END USART2_Init 0 */

  /* USER CODE BEGIN USART2_Init 1 */

  /* USER CODE END USART2_Init 1 */
  huart2.Instance = USART2;
  huart2.Init.BaudRate = 57600;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART2_Init 2 */

  /* USER CODE END USART2_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
